{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v1"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"dedicatedCloud.ObjectRight":{"type":"object","description":"User object right","properties":{"name":{"type":"string","description":"Name of the object","readOnly":true},"objectRightId":{"type":"integer","readOnly":true},"propagate":{"type":"boolean","description":"Right propagation on children objects","readOnly":true},"right":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.right.RightEnum"}],"description":"User access on the VMware object","readOnly":true},"type":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.right.UserObjectRightTypeEnum"}],"description":"Type of the object","readOnly":true},"vmwareObjectId":{"type":"string","description":"The VMware MoRef of the object","readOnly":true}}},"dedicatedCloud.Right":{"type":"object","description":"User datacenter right","properties":{"canAddRessource":{"type":"boolean","description":"Determine if the user can add ressources in your VMware on OVHcloud"},"datacenterId":{"type":"integer","readOnly":true},"networkRole":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.right.NetworkRoleEnum"}],"description":"Determine how this user can interact with the VMware on OVHcloud V(x)Lans"},"right":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.right.RightEnum"}],"description":"Determine what kind of access the User will have in this Datacenter of your VMware on OVHcloud"},"rightId":{"type":"integer","readOnly":true},"vmNetworkRole":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.right.VmNetworkRoleEnum"}],"description":"Determine how this user can interact with the VMware on OVHcloud VM Network"}}},"dedicatedCloud.Task":{"type":"object","description":"Operation","properties":{"createdBy":{"type":"string","description":"Creator of the task","nullable":true,"readOnly":true},"createdFrom":{"type":"string","description":"Origin of the task","nullable":true,"readOnly":true},"datacenterId":{"type":"integer","description":"datacenterId of the associated dedicatedCloud.Datacenter object","nullable":true,"readOnly":true},"description":{"type":"string","description":"Current progress description","nullable":true,"readOnly":true},"endDate":{"type":"string","description":"Task end date","nullable":true,"format":"date-time","readOnly":true},"executionDate":{"type":"string","description":"Task execution date","format":"date-time","readOnly":true},"filerId":{"type":"integer","description":"filerId of the associated dedicatedCloud.Filer object","nullable":true,"readOnly":true},"hostId":{"type":"integer","description":"hostId of the associated dedicatedCloud.Host object","nullable":true,"readOnly":true},"lastModificationDate":{"type":"string","description":"Task last modification date","nullable":true,"format":"date-time","readOnly":true},"maintenanceDateFrom":{"type":"string","description":"Maintenance task min allowed execution date","nullable":true,"format":"date-time","readOnly":true},"maintenanceDateTo":{"type":"string","description":"Maintenance task max allowed execution date","nullable":true,"format":"date-time","readOnly":true},"name":{"type":"string","description":"Task name","readOnly":true},"network":{"type":"string","description":"network of the associated dedicatedCloud.Ip object","nullable":true,"readOnly":true},"networkAccessId":{"type":"integer","description":"networkAccessId of the associated dedicatedCloud.AllowedNetwork object","nullable":true,"readOnly":true},"orderId":{"type":"integer","description":"orderId of the associated billing.Order object","nullable":true,"readOnly":true},"parentTaskId":{"type":"integer","description":"taskId of the parent dedicatedCloud.Task object","nullable":true,"readOnly":true},"progress":{"type":"integer","description":"Current progress","readOnly":true},"state":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.TaskStateEnum"}],"description":"Current Task state","readOnly":true},"taskId":{"type":"integer","description":"Task id","readOnly":true},"type":{"type":"string","description":"Task type","readOnly":true},"userId":{"type":"integer","description":"userId of the associated dedicatedCloud.User object","nullable":true,"readOnly":true},"vlanId":{"type":"integer","description":"vlanId of the parent dedicatedCloud.Vlan object","nullable":true,"readOnly":true}}},"dedicatedCloud.TaskStateEnum":{"type":"string","description":"All states a Dedicated Cloud Task can be in","enum":["canceled","doing","done","error","fixing","toCancel","toCreate","todo","unknown","waitingForChilds","waitingTodo"]},"dedicatedCloud.User":{"type":"object","description":"User","properties":{"activationState":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.user.ActivationStateEnum"}],"description":"Activation state of the user account","nullable":true,"readOnly":true},"activeDirectoryId":{"type":"integer","description":"Deprecated - Linked Federation Active Directory (if any)","nullable":true,"readOnly":true},"activeDirectoryType":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.user.TypeEnum"}],"description":"Deprecated - Federation Active Directory User type (if any)","nullable":true,"readOnly":true},"canManageIpFailOvers":{"type":"boolean","description":"Defines if the user can manage ip failovers","readOnly":true},"canManageNetwork":{"type":"boolean","description":"Defines if the user can manage the network","readOnly":true},"canManageRights":{"type":"boolean","description":"Defines if the user can manage users rights","readOnly":true},"email":{"type":"string","description":"Email address of the user","nullable":true,"readOnly":true},"encryptionRight":{"type":"boolean","description":"Defines if the user can manage encryption / KMS configuration","readOnly":true},"firstName":{"type":"string","description":"First name of the user","nullable":true,"readOnly":true},"fullAdminRo":{"type":"boolean","description":"Defines if the user is a full admin in readonly","readOnly":true},"identityProviderId":{"type":"integer","description":"Linked Identity Provider (if any), can be Federation Active Directory or IAM","nullable":true,"readOnly":true},"identityProviderType":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.user.IdentityProviderTypeEnum"}],"description":"Linked Identity Provider type (if any), can be Federation Active Directory or IAM","nullable":true,"readOnly":true},"isEnableManageable":{"type":"boolean","description":"Check if the given VMware on OVHcloud user can be enabled or disabled ?","readOnly":true},"isTokenValidator":{"type":"boolean","description":"Defines if the user can confirm security tokens (if a compatible option is enabled)","readOnly":true},"lastName":{"type":"string","description":"Last name of the user","nullable":true,"readOnly":true},"login":{"type":"string","description":"Login of the user","readOnly":true},"name":{"type":"string","description":"Name of the user","readOnly":true},"nsxRight":{"type":"boolean","description":"Is this User able to access nsx interface (requires NSX option)","readOnly":true},"phoneNumber":{"type":"string","description":"Mobile phone number of the user","nullable":true,"readOnly":true},"receiveAlerts":{"type":"boolean","description":"Defines if the user receives technical alerts","readOnly":true},"state":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.user.StateEnum"}],"description":"State of the user account","readOnly":true},"type":{"allOf":[{"$ref":"#/components/schemas/dedicatedCloud.user.TypeEnum"}],"description":"User type (if any)","nullable":true,"readOnly":true},"userId":{"type":"integer","readOnly":true}}},"dedicatedCloud.right.NetworkRoleEnum":{"type":"string","description":"Determine how this user can act on the Dedicated Cloud vLans or vxLans","enum":["admin","manager","noAccess","readonly"]},"dedicatedCloud.right.RightEnum":{"type":"string","description":"All rights a Dedicated Cloud user may be associated with","enum":["admin","disabled","readonly","readwrite"]},"dedicatedCloud.right.UserObjectRightTypeEnum":{"type":"string","description":"All types of objects handled in objectRights","enum":["cluster","datastore","dvportgroup","folder","pool","vm"]},"dedicatedCloud.right.VmNetworkRoleEnum":{"type":"string","description":"Determine how this user can act on the Dedicated Cloud vmNetwork","enum":["admin","noAccess","readonly"]},"dedicatedCloud.user.ActivationStateEnum":{"type":"string","description":"All activation states a Dedicated Cloud User can have","enum":["disabled","disabling","enabled","enabling","toDisable","toEnable"]},"dedicatedCloud.user.IdentityProviderTypeEnum":{"type":"string","description":"The type of the identity provider","enum":["federation","iam"]},"dedicatedCloud.user.StateEnum":{"type":"string","description":"All states a Dedicated Cloud User can be in","enum":["creating","deleting","delivered","error"]},"dedicatedCloud.user.TypeEnum":{"type":"string","description":"The type of the user","enum":["group","user"]},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/dedicatedCloud/{serviceName}/user":{"get":{"summary":"List users","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"query","name":"name","description":"Filter the value of name property (like)","schema":{"type":"string"}},{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"type":"integer"}}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/dedicatedCloud/{serviceName}/user\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/dedicatedCloud/{serviceName}/user\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/get","required":true}],"x-expanded-response":"DedicatedCloudUser"},"post":{"summary":"Create a user","description":"Create a user. Creates a user. Its `right` applies to all datacenters and is disabled by default. Without a password, a random one is generated and sent by email.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"canAddRessource":{"type":"boolean","description":"Is this User able to add ressources in the Datacenter he has access ? (default is no right to add ressource)"},"canManageRights":{"type":"boolean","description":"Is this user able to manage the users rights"},"email":{"type":"string","description":"The user email. If this field is empty, user informations will be sent to the dedicatedCloud administrator contact."},"encryptionRight":{"type":"boolean","description":"Defines if the user can manage encryption / KMS configuration"},"expirationDate":{"type":"string","description":"Date of removal of the user.","format":"date-time"},"firstName":{"type":"string","description":"First name of the user"},"lastName":{"type":"string","description":"Last name of the user"},"name":{"type":"string","description":"Name of the user (login)"},"networkRole":{"description":"Determine how this user will be able to act on this VMware on OVHcloud v(x)Lans","$ref":"#/components/schemas/dedicatedCloud.right.NetworkRoleEnum"},"nsxRight":{"type":"boolean","description":"Is this User able to access nsx interface (requires NSX option)"},"password":{"type":"string","description":"The user password. It must fits your VMware on OVHcloud password policy. If this field is empty, a random password will be generated and sent by email.","format":"password"},"phoneNumber":{"type":"string","description":"Mobile phone number of the user"},"receiveAlerts":{"type":"boolean","description":"Defines if the user receives technical alerts"},"right":{"description":"Determine what kind of access the User will have in all Datacenters of your VMware on OVHcloud (default is disabled)","$ref":"#/components/schemas/dedicatedCloud.right.RightEnum"},"tokenValidator":{"type":"boolean","description":"Defines if the user can confirm security tokens (if a compatible option is enabled)"},"vmNetworkRole":{"description":"Determine how this user will be able to act on this VMware on OVHcloud VM Network","$ref":"#/components/schemas/dedicatedCloud.right.VmNetworkRoleEnum"}},"required":["name"]}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.post(\"/dedicatedCloud/{serviceName}/user\",\n\tcanAddRessource = None, # Is this User able to add ressources in the Datacenter he has access ? (default is no right to add ressource) (type: boolean, nullable)\n\tcanManageRights = None, # Is this user able to manage the users rights (type: boolean, nullable)\n\temail = None, # The user email. If this field is empty, user informations will be sent to the dedicatedCloud administrator contact. (type: string, nullable)\n\tencryptionRight = None, # Defines if the user can manage encryption / KMS configuration (type: boolean, nullable)\n\texpirationDate = None, # Date of removal of the user. (type: datetime, nullable)\n\tfirstName = None, # First name of the user (type: string, nullable)\n\tlastName = None, # Last name of the user (type: string, nullable)\n\tname = None, # Name of the user (login) (type: string)\n\tnetworkRole = None, # Determine how this user will be able to act on this VMware on OVHcloud v(x)Lans (type: dedicatedCloud.right.NetworkRoleEnum, nullable)\n\tnsxRight = None, # Is this User able to access nsx interface (requires NSX option) (type: boolean, nullable)\n\tpassword = None, # The user password. It must fits your VMware on OVHcloud password policy. If this field is empty, a random password will be generated and sent by email. (type: password, nullable)\n\tphoneNumber = None, # Mobile phone number of the user (type: string, nullable)\n\treceiveAlerts = None, # Defines if the user receives technical alerts (type: boolean, nullable)\n\tright = None, # Determine what kind of access the User will have in all Datacenters of your VMware on OVHcloud (default is disabled) (type: dedicatedCloud.right.RightEnum, nullable)\n\ttokenValidator = None, # Defines if the user can confirm security tokens (if a compatible option is enabled) (type: boolean, nullable)\n\tvmNetworkRole = None, # Determine how this user will be able to act on this VMware on OVHcloud VM Network (type: dedicatedCloud.right.VmNetworkRoleEnum, nullable)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->post(\"/dedicatedCloud/{serviceName}/user\", array(\n\tcanAddRessource => null, // Is this User able to add ressources in the Datacenter he has access ? (default is no right to add ressource) (type: boolean, nullable)\n\tcanManageRights => null, // Is this user able to manage the users rights (type: boolean, nullable)\n\temail => null, // The user email. If this field is empty, user informations will be sent to the dedicatedCloud administrator contact. (type: string, nullable)\n\tencryptionRight => null, // Defines if the user can manage encryption / KMS configuration (type: boolean, nullable)\n\texpirationDate => null, // Date of removal of the user. (type: datetime, nullable)\n\tfirstName => null, // First name of the user (type: string, nullable)\n\tlastName => null, // Last name of the user (type: string, nullable)\n\tname => null, // Name of the user (login) (type: string)\n\tnetworkRole => null, // Determine how this user will be able to act on this VMware on OVHcloud v(x)Lans (type: dedicatedCloud.right.NetworkRoleEnum, nullable)\n\tnsxRight => null, // Is this User able to access nsx interface (requires NSX option) (type: boolean, nullable)\n\tpassword => null, // The user password. It must fits your VMware on OVHcloud password policy. If this field is empty, a random password will be generated and sent by email. (type: password, nullable)\n\tphoneNumber => null, // Mobile phone number of the user (type: string, nullable)\n\treceiveAlerts => null, // Defines if the user receives technical alerts (type: boolean, nullable)\n\tright => null, // Determine what kind of access the User will have in all Datacenters of your VMware on OVHcloud (default is disabled) (type: dedicatedCloud.right.RightEnum, nullable)\n\ttokenValidator => null, // Defines if the user can confirm security tokens (if a compatible option is enabled) (type: boolean, nullable)\n\tvmNetworkRole => null, // Determine how this user will be able to act on this VMware on OVHcloud VM Network (type: dedicatedCloud.right.VmNetworkRoleEnum, nullable)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/create","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}":{"delete":{"summary":"Delete a user","description":"Delete a user. Deletes the user. To block its access without deleting it, use `disable` instead. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@30"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.delete(\"/dedicatedCloud/{serviceName}/user/{userId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->delete(\"/dedicatedCloud/{serviceName}/user/{userId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/delete","required":true}]},"get":{"summary":"Get a user","description":"Get a user. Returns the user: login, contact details, activation state, permissions and identity provider.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.User"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/dedicatedCloud/{serviceName}/user/{userId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/dedicatedCloud/{serviceName}/user/{userId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/get","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}/changePassword":{"post":{"summary":"Change a user password","description":"Change a user password. Sets a new password that follows the password policy. Without a password, a random one is generated and sent by email. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"password":{"type":"string","description":"New password for this VMware on OVHcloud user. It must fit your VMware on OVHcloud password policy. If this field is empty, a random password will be generated and sent by email.","format":"password"}}}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: password\nresult = client.post(\"/dedicatedCloud/{serviceName}/user/{userId}/changePassword\",\n\tpassword = None, # New password for this VMware on OVHcloud user. It must fit your VMware on OVHcloud password policy. If this field is empty, a random password will be generated and sent by email. (type: password, nullable)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: password\n$result = $ovh->post(\"/dedicatedCloud/{serviceName}/user/{userId}/changePassword\", array(\n\tpassword => null, // New password for this VMware on OVHcloud user. It must fit your VMware on OVHcloud password policy. If this field is empty, a random password will be generated and sent by email. (type: password, nullable)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/changePassword","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}/changeProperties":{"post":{"summary":"Update a user","description":"Update a user. Updates the name, email address, phone number and permissions of the user. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"canManageIpFailOvers":{"type":"boolean","description":"Defines if the user can manage ip failovers"},"canManageNetwork":{"type":"boolean","description":"Defines if the user can manage the network"},"canManageRights":{"type":"boolean","description":"Defines if the user can manage the users rights"},"email":{"type":"string","description":"Email address of the user"},"encryptionRight":{"type":"boolean","description":"Defines if the user can manage encryption / KMS configuration"},"firstName":{"type":"string","description":"First name of the user"},"fullAdminRo":{"type":"boolean","description":"Defines if the user is a full admin in readonly"},"lastName":{"type":"string","description":"Last name of the user"},"nsxRight":{"type":"boolean","description":"Is this User able to access nsx interface (requires NSX option)"},"phoneNumber":{"type":"string","description":"Mobile phone number of the user in international format (+prefix.number)"},"receiveAlerts":{"type":"boolean","description":"Defines if the user receives technical alerts"},"tokenValidator":{"type":"boolean","description":"Defines if the user can confirm security tokens (if a compatible option is enabled)"}}}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.post(\"/dedicatedCloud/{serviceName}/user/{userId}/changeProperties\",\n\tcanManageIpFailOvers = None, # Defines if the user can manage ip failovers (type: boolean, nullable)\n\tcanManageNetwork = None, # Defines if the user can manage the network (type: boolean, nullable)\n\tcanManageRights = None, # Defines if the user can manage the users rights (type: boolean, nullable)\n\temail = None, # Email address of the user (type: string, nullable)\n\tencryptionRight = None, # Defines if the user can manage encryption / KMS configuration (type: boolean, nullable)\n\tfirstName = None, # First name of the user (type: string, nullable)\n\tfullAdminRo = None, # Defines if the user is a full admin in readonly (type: boolean, nullable)\n\tlastName = None, # Last name of the user (type: string, nullable)\n\tnsxRight = None, # Is this User able to access nsx interface (requires NSX option) (type: boolean, nullable)\n\tphoneNumber = None, # Mobile phone number of the user in international format (+prefix.number) (type: string, nullable)\n\treceiveAlerts = None, # Defines if the user receives technical alerts (type: boolean, nullable)\n\ttokenValidator = None, # Defines if the user can confirm security tokens (if a compatible option is enabled) (type: boolean, nullable)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->post(\"/dedicatedCloud/{serviceName}/user/{userId}/changeProperties\", array(\n\tcanManageIpFailOvers => null, // Defines if the user can manage ip failovers (type: boolean, nullable)\n\tcanManageNetwork => null, // Defines if the user can manage the network (type: boolean, nullable)\n\tcanManageRights => null, // Defines if the user can manage the users rights (type: boolean, nullable)\n\temail => null, // Email address of the user (type: string, nullable)\n\tencryptionRight => null, // Defines if the user can manage encryption / KMS configuration (type: boolean, nullable)\n\tfirstName => null, // First name of the user (type: string, nullable)\n\tfullAdminRo => null, // Defines if the user is a full admin in readonly (type: boolean, nullable)\n\tlastName => null, // Last name of the user (type: string, nullable)\n\tnsxRight => null, // Is this User able to access nsx interface (requires NSX option) (type: boolean, nullable)\n\tphoneNumber => null, // Mobile phone number of the user in international format (+prefix.number) (type: string, nullable)\n\treceiveAlerts => null, // Defines if the user receives technical alerts (type: boolean, nullable)\n\ttokenValidator => null, // Defines if the user can confirm security tokens (if a compatible option is enabled) (type: boolean, nullable)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/changeProperties","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}/confirmPhoneNumber":{"post":{"summary":"Confirm a user phone number","description":"Confirm a user phone number. Confirms the phone number with the token sent by SMS. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"token":{"type":"string","description":"Token sent by SMS","format":"password"}},"required":["token"]}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: password\nresult = client.post(\"/dedicatedCloud/{serviceName}/user/{userId}/confirmPhoneNumber\",\n\ttoken = None, # Token sent by SMS (type: password)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: password\n$result = $ovh->post(\"/dedicatedCloud/{serviceName}/user/{userId}/confirmPhoneNumber\", array(\n\ttoken => null, // Token sent by SMS (type: password)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/confirmPhoneNumber","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}/disable":{"post":{"summary":"Disable a user","description":"Disable a user. Disables the user account. Check `isEnableManageable` on the user first. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.post(\"/dedicatedCloud/{serviceName}/user/{userId}/disable\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->post(\"/dedicatedCloud/{serviceName}/user/{userId}/disable\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/disable","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}/enable":{"post":{"summary":"Enable a user","description":"Enable a user. Enables the user account. Check `isEnableManageable` on the user first. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.post(\"/dedicatedCloud/{serviceName}/user/{userId}/enable\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->post(\"/dedicatedCloud/{serviceName}/user/{userId}/enable\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/enable","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}/objectRight":{"get":{"summary":"List user object rights","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"type":"integer"}}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/dedicatedCloud/{serviceName}/user/{userId}/objectRight\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/dedicatedCloud/{serviceName}/user/{userId}/objectRight\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/objectRight/get","required":true}],"x-expanded-response":"DedicatedCloudObjectRight"},"post":{"summary":"Create a user object right","description":"Create a user object right. Gives the user a right on a VMware object, given by its MoRef: cluster, datastore, portgroup, folder, pool or virtual machine. The right can propagate to child objects. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"propagate":{"type":"boolean","description":"Right propagation on children objects"},"right":{"description":"User access on the VMware object","$ref":"#/components/schemas/dedicatedCloud.right.RightEnum"},"type":{"description":"Type of the object","$ref":"#/components/schemas/dedicatedCloud.right.UserObjectRightTypeEnum"},"vmwareObjectId":{"type":"string","description":"The VMware MoRef of the object"}},"required":["right","type","vmwareObjectId"]}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.post(\"/dedicatedCloud/{serviceName}/user/{userId}/objectRight\",\n\tpropagate = None, # Right propagation on children objects (type: boolean, nullable)\n\tright = None, # User access on the VMware object (type: dedicatedCloud.right.RightEnum)\n\ttype = None, # Type of the object (type: dedicatedCloud.right.UserObjectRightTypeEnum)\n\tvmwareObjectId = None, # The VMware MoRef of the object (type: string)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->post(\"/dedicatedCloud/{serviceName}/user/{userId}/objectRight\", array(\n\tpropagate => null, // Right propagation on children objects (type: boolean, nullable)\n\tright => null, // User access on the VMware object (type: dedicatedCloud.right.RightEnum)\n\ttype => null, // Type of the object (type: dedicatedCloud.right.UserObjectRightTypeEnum)\n\tvmwareObjectId => null, // The VMware MoRef of the object (type: string)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/objectRight/create","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}/objectRight/{objectRightId}":{"delete":{"summary":"Delete a user object right","description":"Delete a user object right. Removes the right of the user on the VMware object. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"objectRightId","required":true,"schema":{"type":"integer"}},{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@30"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.delete(\"/dedicatedCloud/{serviceName}/user/{userId}/objectRight/{objectRightId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->delete(\"/dedicatedCloud/{serviceName}/user/{userId}/objectRight/{objectRightId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/objectRight/delete","required":true}]},"get":{"summary":"Get a user object right","description":"Get a user object right. Returns the right of the user on a VMware object: object type, MoRef, access level and propagation.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"objectRightId","required":true,"schema":{"type":"integer"}},{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.ObjectRight"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/dedicatedCloud/{serviceName}/user/{userId}/objectRight/{objectRightId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/dedicatedCloud/{serviceName}/user/{userId}/objectRight/{objectRightId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/objectRight/get","required":true}]}},"/dedicatedCloud/{serviceName}/user/{userId}/right":{"get":{"summary":"List user datacenter rights","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"type":"integer"}}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/dedicatedCloud/{serviceName}/user/{userId}/right\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/dedicatedCloud/{serviceName}/user/{userId}/right\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/right/get","required":true}],"x-expanded-response":"DedicatedCloudRight"}},"/dedicatedCloud/{serviceName}/user/{userId}/right/{rightId}":{"get":{"summary":"Get a user datacenter right","description":"Get a user datacenter right. Returns the access of the user on a datacenter: access level, network and VM network roles, and right to add resources.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"rightId","required":true,"schema":{"type":"integer"}},{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Right"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/dedicatedCloud/{serviceName}/user/{userId}/right/{rightId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/dedicatedCloud/{serviceName}/user/{userId}/right/{rightId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/right/get","required":true}]},"put":{"summary":"Update a user datacenter right","description":"Update a user datacenter right. Updates the access level, the network and VM network roles, and the right to add resources. Returns a task to track progress.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"rightId","required":true,"schema":{"type":"integer"}},{"in":"path","name":"serviceName","description":"Domain of the service","required":true,"schema":{"type":"string"}},{"in":"path","name":"userId","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Right"}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dedicatedCloud.Task"}}}}},"x-developer-hub-navigation":[["Private Cloud","Managed VMware","Managed VMware vSphere","Users@@@40"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: dedicatedCloud.Right\nresult = client.put(\"/dedicatedCloud/{serviceName}/user/{userId}/right/{rightId}\",\n\tcanAddRessource = None, # Determine if the user can add ressources in your VMware on OVHcloud (type: boolean)\n\tnetworkRole = None, # Determine how this user can interact with the VMware on OVHcloud V(x)Lans (type: dedicatedCloud.right.NetworkRoleEnum)\n\tright = None, # Determine what kind of access the User will have in this Datacenter of your VMware on OVHcloud (type: dedicatedCloud.right.RightEnum)\n\tvmNetworkRole = None, # Determine how this user can interact with the VMware on OVHcloud VM Network (type: dedicatedCloud.right.VmNetworkRoleEnum)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: dedicatedCloud.Right\n$result = $ovh->put(\"/dedicatedCloud/{serviceName}/user/{userId}/right/{rightId}\", array(\n\tcanAddRessource => null, // Determine if the user can add ressources in your VMware on OVHcloud (type: boolean)\n\tnetworkRole => null, // Determine how this user can interact with the VMware on OVHcloud V(x)Lans (type: dedicatedCloud.right.NetworkRoleEnum)\n\tright => null, // Determine what kind of access the User will have in this Datacenter of your VMware on OVHcloud (type: dedicatedCloud.right.RightEnum)\n\tvmNetworkRole => null, // Determine how this user can interact with the VMware on OVHcloud VM Network (type: dedicatedCloud.right.VmNetworkRoleEnum)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"pccVMware:apiovh:user/right/edit","required":true}]}}}}
